# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Storage::Mgmt::V2019_06_01
  module Models
    #
    # Settings properties for Active Directory (AD).
    #
    class ActiveDirectoryProperties

      include MsRestAzure

      # @return [String] Specifies the primary domain that the AD DNS server is
      # authoritative for.
      attr_accessor :domain_name

      # @return [String] Specifies the NetBIOS domain name.
      attr_accessor :net_bios_domain_name

      # @return [String] Specifies the Active Directory forest to get.
      attr_accessor :forest_name

      # @return [String] Specifies the domain GUID.
      attr_accessor :domain_guid

      # @return [String] Specifies the security identifier (SID).
      attr_accessor :domain_sid

      # @return [String] Specifies the security identifier (SID) for Azure
      # Storage.
      attr_accessor :azure_storage_sid


      #
      # Mapper for ActiveDirectoryProperties class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ActiveDirectoryProperties',
          type: {
            name: 'Composite',
            class_name: 'ActiveDirectoryProperties',
            model_properties: {
              domain_name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'domainName',
                type: {
                  name: 'String'
                }
              },
              net_bios_domain_name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'netBiosDomainName',
                type: {
                  name: 'String'
                }
              },
              forest_name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'forestName',
                type: {
                  name: 'String'
                }
              },
              domain_guid: {
                client_side_validation: true,
                required: true,
                serialized_name: 'domainGuid',
                type: {
                  name: 'String'
                }
              },
              domain_sid: {
                client_side_validation: true,
                required: true,
                serialized_name: 'domainSid',
                type: {
                  name: 'String'
                }
              },
              azure_storage_sid: {
                client_side_validation: true,
                required: true,
                serialized_name: 'azureStorageSid',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
