# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Storage::Mgmt::V2019_06_01
  module Models
    #
    # A service that allows server-side encryption to be used.
    #
    class EncryptionService

      include MsRestAzure

      # @return [Boolean] A boolean indicating whether or not the service
      # encrypts the data as it is stored.
      attr_accessor :enabled

      # @return [DateTime] Gets a rough estimate of the date/time when the
      # encryption was last enabled by the user. Only returned when encryption
      # is enabled. There might be some unencrypted blobs which were written
      # after this time, as it is just a rough estimate.
      attr_accessor :last_enabled_time

      # @return [KeyType] Encryption key type to be used for the encryption
      # service. 'Account' key type implies that an account-scoped encryption
      # key will be used. 'Service' key type implies that a default service key
      # is used. Possible values include: 'Service', 'Account'
      attr_accessor :key_type


      #
      # Mapper for EncryptionService class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'EncryptionService',
          type: {
            name: 'Composite',
            class_name: 'EncryptionService',
            model_properties: {
              enabled: {
                client_side_validation: true,
                required: false,
                serialized_name: 'enabled',
                type: {
                  name: 'Boolean'
                }
              },
              last_enabled_time: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'lastEnabledTime',
                type: {
                  name: 'DateTime'
                }
              },
              key_type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'keyType',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
