# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Storage::Mgmt::V2019_06_01
  module Models
    #
    # The properties of File services in storage account.
    #
    class FileServiceProperties < Resource

      include MsRestAzure

      # @return [CorsRules] Specifies CORS rules for the File service. You can
      # include up to five CorsRule elements in the request. If no CorsRule
      # elements are included in the request body, all CORS rules will be
      # deleted, and CORS will be disabled for the File service.
      attr_accessor :cors

      # @return [DeleteRetentionPolicy] The file service properties for share
      # soft delete.
      attr_accessor :share_delete_retention_policy

      # @return [Sku] Sku name and tier.
      attr_accessor :sku


      #
      # Mapper for FileServiceProperties class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'FileServiceProperties',
          type: {
            name: 'Composite',
            class_name: 'FileServiceProperties',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              cors: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.cors',
                type: {
                  name: 'Composite',
                  class_name: 'CorsRules'
                }
              },
              share_delete_retention_policy: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.shareDeleteRetentionPolicy',
                type: {
                  name: 'Composite',
                  class_name: 'DeleteRetentionPolicy'
                }
              },
              sku: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'sku',
                type: {
                  name: 'Composite',
                  class_name: 'Sku'
                }
              }
            }
          }
        }
      end
    end
  end
end
