# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Storage::Mgmt::V2020_08_01_preview
  module Models
    #
    # Deleted storage account
    #
    class DeletedAccount < ProxyResource

      include MsRestAzure

      # @return [String] Full resource id of the original storage account.
      attr_accessor :storage_account_resource_id

      # @return [String] Location of the deleted account.
      attr_accessor :location

      # @return [String] Can be used to attempt recovering this deleted account
      # via PutStorageAccount API.
      attr_accessor :restore_reference

      # @return [String] Creation time of the deleted account.
      attr_accessor :creation_time

      # @return [String] Deletion time of the deleted account.
      attr_accessor :deletion_time


      #
      # Mapper for DeletedAccount class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'DeletedAccount',
          type: {
            name: 'Composite',
            class_name: 'DeletedAccount',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              storage_account_resource_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.storageAccountResourceId',
                type: {
                  name: 'String'
                }
              },
              location: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.location',
                type: {
                  name: 'String'
                }
              },
              restore_reference: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.restoreReference',
                type: {
                  name: 'String'
                }
              },
              creation_time: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.creationTime',
                type: {
                  name: 'String'
                }
              },
              deletion_time: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.deletionTime',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
