# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Storage::Mgmt::V2020_08_01_preview
  module Models
    #
    # Routing preference defines the type of network, either microsoft or
    # internet routing to be used to deliver the user data, the default option
    # is microsoft routing
    #
    class RoutingPreference

      include MsRestAzure

      # @return [RoutingChoice] Routing Choice defines the kind of network
      # routing opted by the user. Possible values include: 'MicrosoftRouting',
      # 'InternetRouting'
      attr_accessor :routing_choice

      # @return [Boolean] A boolean flag which indicates whether microsoft
      # routing storage endpoints are to be published
      attr_accessor :publish_microsoft_endpoints

      # @return [Boolean] A boolean flag which indicates whether internet
      # routing storage endpoints are to be published
      attr_accessor :publish_internet_endpoints


      #
      # Mapper for RoutingPreference class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'RoutingPreference',
          type: {
            name: 'Composite',
            class_name: 'RoutingPreference',
            model_properties: {
              routing_choice: {
                client_side_validation: true,
                required: false,
                serialized_name: 'routingChoice',
                type: {
                  name: 'String'
                }
              },
              publish_microsoft_endpoints: {
                client_side_validation: true,
                required: false,
                serialized_name: 'publishMicrosoftEndpoints',
                type: {
                  name: 'Boolean'
                }
              },
              publish_internet_endpoints: {
                client_side_validation: true,
                required: false,
                serialized_name: 'publishInternetEndpoints',
                type: {
                  name: 'Boolean'
                }
              }
            }
          }
        }
      end
    end
  end
end
