# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Storage::Mgmt::V2021_01_01
  module Models
    #
    # The storage account blob inventory policy.
    #
    class BlobInventoryPolicy < Resource

      include MsRestAzure

      # @return [DateTime] Returns the last modified date and time of the blob
      # inventory policy.
      attr_accessor :last_modified_time

      # @return [BlobInventoryPolicySchema] The storage account blob inventory
      # policy object. It is composed of policy rules.
      attr_accessor :policy

      # @return [SystemData]
      attr_accessor :system_data


      #
      # Mapper for BlobInventoryPolicy class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'BlobInventoryPolicy',
          type: {
            name: 'Composite',
            class_name: 'BlobInventoryPolicy',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              last_modified_time: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.lastModifiedTime',
                type: {
                  name: 'DateTime'
                }
              },
              policy: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.policy',
                default_value: {},
                type: {
                  name: 'Composite',
                  class_name: 'BlobInventoryPolicySchema'
                }
              },
              system_data: {
                client_side_validation: true,
                required: false,
                serialized_name: 'systemData',
                type: {
                  name: 'Composite',
                  class_name: 'SystemData'
                }
              }
            }
          }
        }
      end
    end
  end
end
