# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Storage::Mgmt::V2021_01_01
  module Models
    #
    # The storage account blob inventory policy rules.
    #
    class BlobInventoryPolicySchema

      include MsRestAzure

      # @return [Boolean] Policy is enabled if set to true.
      attr_accessor :enabled

      # @return [String] Container name where blob inventory files are stored.
      # Must be pre-created.
      attr_accessor :destination

      # @return [String] The valid value is Inventory. Default value:
      # 'Inventory' .
      attr_accessor :type

      # @return [Array<BlobInventoryPolicyRule>] The storage account blob
      # inventory policy rules. The rule is applied when it is enabled.
      attr_accessor :rules


      #
      # Mapper for BlobInventoryPolicySchema class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'BlobInventoryPolicySchema',
          type: {
            name: 'Composite',
            class_name: 'BlobInventoryPolicySchema',
            model_properties: {
              enabled: {
                client_side_validation: true,
                required: true,
                serialized_name: 'enabled',
                type: {
                  name: 'Boolean'
                }
              },
              destination: {
                client_side_validation: true,
                required: true,
                serialized_name: 'destination',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: true,
                is_constant: true,
                serialized_name: 'type',
                default_value: 'Inventory',
                type: {
                  name: 'String'
                }
              },
              rules: {
                client_side_validation: true,
                required: true,
                serialized_name: 'rules',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'BlobInventoryPolicyRuleElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'BlobInventoryPolicyRule'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
