# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Storage::Mgmt::V2021_01_01
  module Models
    #
    # The key vault properties for the encryption scope. This is a required
    # field if encryption scope 'source' attribute is set to
    # 'Microsoft.KeyVault'.
    #
    class EncryptionScopeKeyVaultProperties

      include MsRestAzure

      # @return [String] The object identifier for a key vault key object. When
      # applied, the encryption scope will use the key referenced by the
      # identifier to enable customer-managed key support on this encryption
      # scope.
      attr_accessor :key_uri

      # @return [String] The object identifier of the current versioned Key
      # Vault Key in use.
      attr_accessor :current_versioned_key_identifier

      # @return [DateTime] Timestamp of last rotation of the Key Vault Key.
      attr_accessor :last_key_rotation_timestamp


      #
      # Mapper for EncryptionScopeKeyVaultProperties class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'EncryptionScopeKeyVaultProperties',
          type: {
            name: 'Composite',
            class_name: 'EncryptionScopeKeyVaultProperties',
            model_properties: {
              key_uri: {
                client_side_validation: true,
                required: false,
                serialized_name: 'keyUri',
                type: {
                  name: 'String'
                }
              },
              current_versioned_key_identifier: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'currentVersionedKeyIdentifier',
                type: {
                  name: 'String'
                }
              },
              last_key_rotation_timestamp: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'lastKeyRotationTimestamp',
                type: {
                  name: 'DateTime'
                }
              }
            }
          }
        }
      end
    end
  end
end
