#
# Copyright:: Copyright (c) Chef Software Inc.
# License:: Apache License, Version 2.0
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

require "spec_helper"

describe Chef::Resource::ChefSleep do
  let(:resource) { Chef::Resource::ChefSleep.new("30") }

  it "sets the default action as :sleep" do
    expect(resource.action).to eql([:sleep])
  end

  it "sleep is the name property and it coerces to an Integer" do
    expect(resource.seconds).to eql(30)
  end
end
